# NOTE: This file is auto-generated. Do not modify.

load ../common

setup () {
    [[ $CH_TEST_BUILDER = ch-image ]] || skip 'ch-image only'
    # FIXME: Would be good to test with build cache enabled, but there are
    # lots of assumptions about output that are not valid in that case.
    [[ $CH_IMAGE_CACHE = disabled ]] || skip 'bucache disabled only'
}


@test "ch-image --force: almalinux:8, unneeded fail, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: almalinux:8, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: almalinux:8, unneeded fail, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"

}

# skip: almalinux:8, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: almalinux:8, unneeded win, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"

}

# skip: almalinux:8, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: almalinux:8, unneeded win, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: almalinux:8, unneeded win, with --force, preprep: not needed

@test "ch-image --force: almalinux:8, fake needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: almalinux:8, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: almalinux:8, fake needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: almalinux:8, fake needed, with --force, preprep: not needed

@test "ch-image --force: almalinux:8, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: almalinux:8, needed, w/o --force, preprep: not needed

@test "ch-image --force: almalinux:8, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM almalinux:8
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: almalinux:8, needed, with --force, preprep" {
scope standard


# build 1: intermediate image for preparatory commands
run ch-image -v build -t tmpimg -f - . << 'EOF'
FROM almalinux:8
RUN dnf install -y epel-release
EOF
echo "$output"
[[ $status -eq 0 ]]


# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM tmpimg
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: alpine:3.9, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: alpine"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: alpine:3.9, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: alpine:3.9, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"

}

# skip: alpine:3.9, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: alpine:3.9, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: alpine"

}

# skip: alpine:3.9, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: alpine:3.9, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: alpine:3.9, unneeded win, with --force, preprep: not needed

@test "ch-image --force: alpine:3.9, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN apk add ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: alpine"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: alpine:3.9, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: alpine:3.9, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN apk add ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: alpine:3.9, fake needed, with --force, preprep: not needed

@test "ch-image --force: alpine:3.9, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN apk add dbus
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: alpine"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: alpine:3.9, needed, w/o --force, preprep: not needed

@test "ch-image --force: alpine:3.9, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:3.9
RUN apk add dbus
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: alpine:3.9, needed, with --force, preprep: no preprep command

@test "ch-image --force: alpine:latest, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: alpine"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: alpine:latest, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: alpine:latest, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"

}

# skip: alpine:latest, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: alpine:latest, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: alpine"

}

# skip: alpine:latest, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: alpine:latest, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: alpine:latest, unneeded win, with --force, preprep: not needed

@test "ch-image --force: alpine:latest, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN apk add ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: alpine"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: alpine:latest, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: alpine:latest, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN apk add ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: alpine:latest, fake needed, with --force, preprep: not needed

@test "ch-image --force: alpine:latest, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN apk add dbus
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: alpine"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: alpine:latest, needed, w/o --force, preprep: not needed

@test "ch-image --force: alpine:latest, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM alpine:latest
RUN apk add dbus
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: alpine"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: alpine:latest, needed, with --force, preprep: no preprep command

@test "ch-image --force: archlinux:latest, unneeded fail, w/o --force, no preprep" {
scope full
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: arch"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: archlinux:latest, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: archlinux:latest, unneeded fail, with --force, no preprep" {
scope full
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: arch"

}

# skip: archlinux:latest, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: archlinux:latest, unneeded win, w/o --force, no preprep" {
scope full
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: arch"

}

# skip: archlinux:latest, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: archlinux:latest, unneeded win, with --force, no preprep" {
scope full
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: arch"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: archlinux:latest, unneeded win, with --force, preprep: not needed

@test "ch-image --force: archlinux:latest, fake needed, w/o --force, no preprep" {
scope full
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN pacman -Syq --noconfirm ed; ! fgrep failed: /var/log/pacman.log
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: arch"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: archlinux:latest, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: archlinux:latest, fake needed, with --force, no preprep" {
scope full
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN pacman -Syq --noconfirm ed; ! fgrep failed: /var/log/pacman.log
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: arch"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: archlinux:latest, fake needed, with --force, preprep: not needed

@test "ch-image --force: archlinux:latest, needed, w/o --force, no preprep" {
scope standard
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN pacman -Syq --noconfirm openssh; ! fgrep failed: /var/log/pacman.log
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: arch"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: archlinux:latest, needed, w/o --force, preprep: not needed

@test "ch-image --force: archlinux:latest, needed, with --force, no preprep" {
scope standard
arch_exclude aarch64
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM archlinux:latest
RUN pacman -Syq --noconfirm openssh; ! fgrep failed: /var/log/pacman.log
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: arch"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: archlinux:latest, needed, with --force, preprep: no preprep command

@test "ch-image --force: centos:7, unneeded fail, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel7"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: centos:7, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: centos:7, unneeded fail, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: rhel7"

}

# skip: centos:7, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: centos:7, unneeded win, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel7"

}

# skip: centos:7, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: centos:7, unneeded win, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel7"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: centos:7, unneeded win, with --force, preprep: not needed

@test "ch-image --force: centos:7, fake needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN yum install -y ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel7"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: centos:7, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: centos:7, fake needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN yum install -y ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel7"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: centos:7, fake needed, with --force, preprep: not needed

@test "ch-image --force: centos:7, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN yum install -y openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel7"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: centos:7, needed, w/o --force, preprep: not needed

@test "ch-image --force: centos:7, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM centos:7
RUN yum install -y openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel7"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: centos:7, needed, with --force, preprep" {
scope standard


# build 1: intermediate image for preparatory commands
run ch-image -v build -t tmpimg -f - . << 'EOF'
FROM centos:7
RUN yum install -y epel-release
EOF
echo "$output"
[[ $status -eq 0 ]]


# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM tmpimg
RUN yum install -y openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel7"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: quay.io/centos/centos:stream8, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: quay.io/centos/centos:stream8, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"

}

# skip: quay.io/centos/centos:stream8, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"

}

# skip: quay.io/centos/centos:stream8, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: quay.io/centos/centos:stream8, unneeded win, with --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: quay.io/centos/centos:stream8, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: quay.io/centos/centos:stream8, fake needed, with --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: quay.io/centos/centos:stream8, needed, w/o --force, preprep: not needed

@test "ch-image --force: quay.io/centos/centos:stream8, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: quay.io/centos/centos:stream8, needed, with --force, preprep" {
scope standard


# build 1: intermediate image for preparatory commands
run ch-image -v build -t tmpimg -f - . << 'EOF'
FROM quay.io/centos/centos:stream8
RUN dnf install -y epel-release
EOF
echo "$output"
[[ $status -eq 0 ]]


# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM tmpimg
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: debian:9, unneeded fail, w/o --force, no preprep" {
scope full
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM debian:9
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: debian:9, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: debian:9, unneeded fail, with --force, no preprep" {
scope full
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM debian:9
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"

}

# skip: debian:9, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: debian:9, unneeded win, w/o --force, no preprep" {
scope full
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM debian:9
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"

}

# skip: debian:9, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: debian:9, unneeded win, with --force, no preprep" {
scope full
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM debian:9
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: debian:9, unneeded win, with --force, preprep: not needed

# skip: debian:9, fake needed, w/o --force, no preprep: no run command

# skip: debian:9, fake needed, w/o --force, preprep: not needed

# skip: debian:9, fake needed, with --force, no preprep: no run command

# skip: debian:9, fake needed, with --force, preprep: not needed

@test "ch-image --force: debian:9, needed, w/o --force, no preprep" {
scope standard
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM debian:9
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: debian:9, needed, w/o --force, preprep: not needed

@test "ch-image --force: debian:9, needed, with --force, no preprep" {
scope standard
arch_exclude ppc64le

# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM debian:9
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: debian:9, needed, with --force, preprep: no preprep command

@test "ch-image --force: debian:latest, unneeded fail, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM debian:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: debian:latest, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: debian:latest, unneeded fail, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM debian:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"

}

# skip: debian:latest, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: debian:latest, unneeded win, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM debian:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"

}

# skip: debian:latest, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: debian:latest, unneeded win, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM debian:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: debian:latest, unneeded win, with --force, preprep: not needed

# skip: debian:latest, fake needed, w/o --force, no preprep: no run command

# skip: debian:latest, fake needed, w/o --force, preprep: not needed

# skip: debian:latest, fake needed, with --force, no preprep: no run command

# skip: debian:latest, fake needed, with --force, preprep: not needed

@test "ch-image --force: debian:latest, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM debian:latest
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: debian:latest, needed, w/o --force, preprep: not needed

@test "ch-image --force: debian:latest, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM debian:latest
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: debian:latest, needed, with --force, preprep: no preprep command

@test "ch-image --force: fedora:26, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: fedora"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: fedora:26, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: fedora:26, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"

}

# skip: fedora:26, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: fedora:26, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: fedora"

}

# skip: fedora:26, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: fedora:26, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: fedora:26, unneeded win, with --force, preprep: not needed

@test "ch-image --force: fedora:26, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: fedora"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: fedora:26, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: fedora:26, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: fedora:26, fake needed, with --force, preprep: not needed

@test "ch-image --force: fedora:26, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: fedora"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: fedora:26, needed, w/o --force, preprep: not needed

@test "ch-image --force: fedora:26, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:26
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: fedora:26, needed, with --force, preprep: no preprep command

@test "ch-image --force: fedora:34, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: fedora"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: fedora:34, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: fedora:34, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"

}

# skip: fedora:34, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: fedora:34, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: fedora"

}

# skip: fedora:34, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: fedora:34, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: fedora:34, unneeded win, with --force, preprep: not needed

@test "ch-image --force: fedora:34, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: fedora"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: fedora:34, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: fedora:34, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: fedora:34, fake needed, with --force, preprep: not needed

@test "ch-image --force: fedora:34, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: fedora"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: fedora:34, needed, w/o --force, preprep: not needed

@test "ch-image --force: fedora:34, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM fedora:34
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: fedora"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: fedora:34, needed, with --force, preprep: no preprep command

@test "ch-image --force: opensuse/leap:15.0, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: suse"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: opensuse/leap:15.0, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: suse"

}

# skip: opensuse/leap:15.0, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: suse"

}

# skip: opensuse/leap:15.0, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: suse"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: opensuse/leap:15.0, unneeded win, with --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN zypper install -y ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: suse"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: opensuse/leap:15.0, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN zypper install -y ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: suse"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: opensuse/leap:15.0, fake needed, with --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN zypper install -y dbus-1
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: suse"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: opensuse/leap:15.0, needed, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:15.0, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:15.0
RUN zypper install -y dbus-1
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: suse"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: opensuse/leap:15.0, needed, with --force, preprep: no preprep command

@test "ch-image --force: opensuse/leap:latest, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: suse"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: opensuse/leap:latest, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: suse"

}

# skip: opensuse/leap:latest, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: suse"

}

# skip: opensuse/leap:latest, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: suse"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: opensuse/leap:latest, unneeded win, with --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN zypper install -y ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: suse"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: opensuse/leap:latest, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN zypper install -y ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: suse"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: opensuse/leap:latest, fake needed, with --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN zypper install -y dbus-1
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: suse"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: opensuse/leap:latest, needed, w/o --force, preprep: not needed

@test "ch-image --force: opensuse/leap:latest, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM opensuse/leap:latest
RUN zypper install -y dbus-1
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: suse"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: opensuse/leap:latest, needed, with --force, preprep: no preprep command

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: registry.access.redhat.com/ubi8/ubi, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"

}

# skip: registry.access.redhat.com/ubi8/ubi, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"

}

# skip: registry.access.redhat.com/ubi8/ubi, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: registry.access.redhat.com/ubi8/ubi, unneeded win, with --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: registry.access.redhat.com/ubi8/ubi, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: registry.access.redhat.com/ubi8/ubi, fake needed, with --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: registry.access.redhat.com/ubi8/ubi, needed, w/o --force, preprep: not needed

@test "ch-image --force: registry.access.redhat.com/ubi8/ubi, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM registry.access.redhat.com/ubi8/ubi
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: registry.access.redhat.com/ubi8/ubi, needed, with --force, preprep: no preprep command

@test "ch-image --force: rockylinux:8, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: rockylinux:8, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: rockylinux:8, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"

}

# skip: rockylinux:8, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: rockylinux:8, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"

}

# skip: rockylinux:8, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: rockylinux:8, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: rockylinux:8, unneeded win, with --force, preprep: not needed

@test "ch-image --force: rockylinux:8, fake needed, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"

}

# skip: rockylinux:8, fake needed, w/o --force, preprep: not needed

@test "ch-image --force: rockylinux:8, fake needed, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN dnf install -y --setopt=install_weak_deps=false ed
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: rockylinux:8, fake needed, with --force, preprep: not needed

@test "ch-image --force: rockylinux:8, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: rhel8"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: rockylinux:8, needed, w/o --force, preprep: not needed

@test "ch-image --force: rockylinux:8, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM rockylinux:8
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: rockylinux:8, needed, with --force, preprep" {
scope standard


# build 1: intermediate image for preparatory commands
run ch-image -v build -t tmpimg -f - . << 'EOF'
FROM rockylinux:8
RUN dnf install -y epel-release
EOF
echo "$output"
[[ $status -eq 0 ]]


# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM tmpimg
RUN dnf install -y --setopt=install_weak_deps=false openssh
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: rhel8"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

@test "ch-image --force: ubuntu:16.04, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:16.04
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: ubuntu:16.04, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: ubuntu:16.04, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:16.04
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"

}

# skip: ubuntu:16.04, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: ubuntu:16.04, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:16.04
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"

}

# skip: ubuntu:16.04, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: ubuntu:16.04, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:16.04
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: ubuntu:16.04, unneeded win, with --force, preprep: not needed

# skip: ubuntu:16.04, fake needed, w/o --force, no preprep: no run command

# skip: ubuntu:16.04, fake needed, w/o --force, preprep: not needed

# skip: ubuntu:16.04, fake needed, with --force, no preprep: no run command

# skip: ubuntu:16.04, fake needed, with --force, preprep: not needed

@test "ch-image --force: ubuntu:16.04, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:16.04
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: ubuntu:16.04, needed, w/o --force, preprep: not needed

@test "ch-image --force: ubuntu:16.04, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:16.04
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: ubuntu:16.04, needed, with --force, preprep: no preprep command

@test "ch-image --force: ubuntu:latest, unneeded fail, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "current version of --force wouldn't help"

}

# skip: ubuntu:latest, unneeded fail, w/o --force, preprep: not needed

@test "ch-image --force: ubuntu:latest, unneeded fail, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:latest
RUN false
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"

}

# skip: ubuntu:latest, unneeded fail, with --force, preprep: not needed

@test "ch-image --force: ubuntu:latest, unneeded win, w/o --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"

}

# skip: ubuntu:latest, unneeded win, w/o --force, preprep: not needed

@test "ch-image --force: ubuntu:latest, unneeded win, with --force, no preprep" {
scope full


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:latest
RUN true
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "warning: --force specified, but nothing to do"

}

# skip: ubuntu:latest, unneeded win, with --force, preprep: not needed

# skip: ubuntu:latest, fake needed, w/o --force, no preprep: no run command

# skip: ubuntu:latest, fake needed, w/o --force, preprep: not needed

# skip: ubuntu:latest, fake needed, with --force, no preprep: no run command

# skip: ubuntu:latest, fake needed, with --force, preprep: not needed

@test "ch-image --force: ubuntu:latest, needed, w/o --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build  -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:latest
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 1 ]]
echo "$output" | grep -Eq -- "available --force: debderiv"
echo "$output" | grep -Eq -- "RUN: available here with --force"
echo "$output" | grep -Eq -- "build failed"
echo "$output" | grep -Eq -- "--force may fix it"

}

# skip: ubuntu:latest, needed, w/o --force, preprep: not needed

@test "ch-image --force: ubuntu:latest, needed, with --force, no preprep" {
scope standard


# build 1: intermediate image for preparatory commands
# skipped: no separate prep

# build 2: image we're testing
run ch-image -v build --force -t tmpimg2 -f - . << 'EOF'
FROM ubuntu:latest
RUN     apt-get update && apt-get install -y openssh-client
EOF
echo "$output"
[[ $status -eq 0 ]]
echo "$output" | grep -Eq -- "will use --force: debderiv"
echo "$output" | grep -Eq -- "--force: init OK & modified 1 RUN instructions"

}

# skip: ubuntu:latest, needed, with --force, preprep: no preprep command
